'----------------------------------------------------------
'	SR2 Chunks Texture Replacement Tool
'	Copyright (c) 2020 Masamichi Kirikae
'----------------------------------------------------------
#include once "SR2ChunksTextureTool.bi"

function AboutDlgProc(byval hWin as HWND,byval uMsg as UINT,byval wParam as WPARAM,byval lParam as LPARAM) as s32
	dim as s32 id,event
	dim lf as LOGFONT

	select case uMsg
		case WM_INITDIALOG
			' Create a back brush
		case WM_COMMAND
			id=loword(wParam)
			event=hiword(wParam)
			if event=BN_CLICKED then
				if id=IDOK then
					SendMessage(hWin,WM_CLOSE,NULL,NULL)
				endif
			endif
			'
		case WM_CLOSE
			EndDialog(hWin,0)
			'
		case else
			return FALSE
			'
	end select
	return TRUE

end function

Function DialogProc(ByVal hWin As HWND, ByVal uMsg As UINT, ByVal wParam As WPARAM, ByVal lParam As LPARAM) As s32
	dim as s32 id, nEvent, flag, ofnFlags, ln, lRes, retval, attrib_mask
	dim as u32 n
	dim as zstring*260 ztemp, buff
	dim as any ptr thread
	static as s32 minval
	dim as string path
	dim as string sourcepath, destpath

	select case uMsg
		case WM_INITDIALOG
			
			InitCommonControls()
			
			DisableProcessWindowsGhosting()
		
			_hDlg = hWin
			
			'	load Icon
			_hIcon = LoadIcon(_hInstance, cast(zstring ptr, 500))
			sendmessage(hWin, WM_SETICON, NULL, cast(LPARAM, _hIcon))
			
			'	initialize dds instructor
			dds.init_dds()
			'	initialize peg instructor
			peg_pc.init_peg()
			
			'	init progress bar
			_hProg = GetDlgItem(hWin, IDC_PGB1)
			_Progress_Val = 0
			SendMessage(_hProg, PBM_SETRANGE, 0, MAKELPARAM( 0, 100 ))
			SendMessage(_hProg, PBM_SETPOS, _Progress_Val, 0)
			
			'	get menuhandle
			_hMenu = LoadMenu(GetModuleHandle(NULL), MAKEINTRESOURCE(IDR_MENU1))
			retval = SetMenu(hWin, _hMenu)
			
			'	read sr2pegtool.ini
			retval = read_inifile(_INIFILE_NAME)
			if (retval = F_ERROR) then
				ztemp = "Syntax error in configuration file." + !"\n\r" + "Do you want to initialize the configuration file?"
				retval = MessageBox(hWin, ztemp, @"Info", MB_YESNO or MB_APPLMODAL)
				if (retval = IDYES)	then
					_sr2path = ""
					_temppath = "temp"
					write_inifile(_INIFILE_NAME)
				else
					EndDialog(hWin, 0)
				endif
			endif
			
			'	List Error Messages and Redraw Menu
			get_error_status()
			reflect_error_status()

		case WM_CLOSE
		
			if (check_thread()) then exit select  

			delete_temporary_subfolders()
			EndDialog(hWin, 0)
		
		case WM_DESTROY
			
			if (check_thread()) then exit select  

			delete_temporary_subfolders()
			PostQuitMessage(NULL)
			'
		case WM_SIZE
			'
		case WM_COMMAND

			id = LoWord(wParam)
			nEvent = HiWord(wParam)


			' Menu, toolbar and accelerator events
			select case nEvent
				case BN_CLICKED, 1
					select case id
						case IDM_FILE_OPEN	' select SR2 installed folder
						
							if (check_thread()) then exit select  
								
							if (_sr2path = "") then
								if (dir("C:\Program Files (x86)\Steam\steamapps\common\Saints Row 2", fbDirectory) <> "") then
									ztemp = "C:\Program Files (x86)\Steam\steamapps\common\Saints Row 2"
								elseif (dir("D:\SteamLibrary\steamapps\common\Saints Row 2", fbDirectory) <> "") then
									ztemp = "D:\SteamLibrary\steamapps\common\Saints Row 2"
								elseif (dir("E:\SteamLibrary\steamapps\common\Saints Row 2", fbDirectory) <> "") then
									ztemp = "E:\SteamLibrary\steamapps\common\Saints Row 2"
								else
									ztemp = _currpath
								endif
							else
								ztemp = _sr2path
							endif
							
							ofnFlags = BIF_NEWDIALOGSTYLE or BIF_RETURNONLYFSDIRS
							buff = FileSelectFolder("Select SR2 Installed Folder", 0, ofnFlags, ztemp)
							
							if (buff <> "") then
								sourcepath = buff + "\chunks1.vpp_pc"
								if (dir(sourcepath, fbArchive) = "") then
									MessageBox(hWin, "chunks1.vpp_pc not found. Select correct folder.", @"Error", MB_OK or MB_APPLMODAL)
									_sr2path = ""
									exit select
								else
									'	set valid SR2 installed folder
									_sr2path = buff
									write_inifile(_INIFILE_NAME)
									_ERROR_STAT = _ERROR_STAT and (not ERROR_NO_SR2FOLDER)
									
									ztemp = "SR2 installed folder is set to" + !"\r\n" + _sr2path
									MessageBox(hWin, ztemp, @"Info", MB_OK or MB_APPLMODAL)
								endif
							endif
							
							if ( check_vpp_pc_files(_ORIGINAL_VPP_PC) = F_ERROR ) then
								_ERROR_STAT = _ERROR_STAT or ERROR_NO_VPPSOURCE
							else
								_ERROR_STAT = _ERROR_STAT and (not ERROR_NO_VPPSOURCE)
							endif
							
							if (_ERROR_STAT and ERROR_NO_VPPSOURCE) then

								MessageBox(hWin, "Copy original chunks1_vpp_pc, chunks2.vpp_pc, chunks3.vpp_pc and pegs.vpp_pc.", @"Info", MB_OK or MB_APPLMODAL)

								dim as any ptr handle
								handle = ThreadCreate(@copy_vpp_pc_sourcefiles)
								ThreadDetach(handle)
								
							else

								MessageBox(hWin, "The original vpp_pc files have already been copied.", @"Info", MB_OK or MB_APPLMODAL)

							endif

							'	error handling
							get_error_status()
							reflect_error_status()
								
						case IDM_FILE_COPY
							
							if (check_thread()) then exit select  

							'	check new_vpp_pc
							retval = check_vpp_pc_files(_REBUILD_VPP_PC)
							if (retval = F_ERROR) then
								ztemp = "The new vpp_pc files not exist."
								MessageBox(hWin, ztemp, @"Info", MB_OK or MB_APPLMODAL)
								exit select
							endif

							ztemp = "Copy new chunks1,2,3 and pegs.vpp_pc files to" + !"\r\n" + _sr2path + "?"
							retval = MessageBox(hWin, ztemp, @"Info", MB_YESNO or MB_APPLMODAL)
							if (retval <> IDYES) then exit select

							dim as any ptr handle
							handle = ThreadCreate(@copy_vpp_pc_newfiles)
							ThreadDetach(handle)
							
						
						case IDM_FILE_INIT
							
							if (check_thread()) then exit select  

							ztemp = "Delete all chunks texture data?"

							retval = MessageBox(hWin, ztemp, @"Info", MB_YESNO or MB_APPLMODAL)
							if (retval <> IDYES) then exit select
							
							dim as any ptr handle
							handle = ThreadCreate(@init_chunks_data)
							ThreadDetach(handle)						
								
						case IDM_FILE_EXIT
							
							if (check_thread()) then exit select  

							delete_temporary_subfolders()
							SendMessage(hWin, WM_CLOSE, 0, 0)
							
						case IDM_EDIT_TEMP
							
							if (check_thread()) then exit select  

							ztemp = _currpath
							ofnFlags = BIF_NEWDIALOGSTYLE or BIF_RETURNONLYFSDIRS
							buff = FileSelectFolder("Select Temporary Folder", 0, ofnFlags, ztemp)
							if (buff <> "") then
								'	check temporary folder setting
								_temppath = buff
								retval = init_temporary_folder()						
								if (retval = F_ERROR) then
									'	invald temp folder
									_ERROR_STAT = _ERROR_STAT or ERROR_NO_TEMPFOLDER
									MessageBox(hWin, "Temporary folder " + buff + " unavailavle.", @"Info", MB_OK or MB_APPLMODAL)
								else
									'	valid temp folder
									scope
										dim as s32 lg1, lg2
	
										lg1 = len(_temppath)
										lg2 = len(_rootpath)
										if (lg1 > lg2) then
											if (left(_temppath, lg2) = _rootpath) then
												_temppath = right(_temppath, lg1 - lg2 - 1)
											endif
										endif
									end scope
									
									_ERROR_STAT = _ERROR_STAT and (not ERROR_NO_TEMPFOLDER)
									
									MessageBox(hWin, "Temporary folder set to " + _temppath , @"Info", MB_OK or MB_APPLMODAL)
									write_inifile(_INIFILE_NAME)

								endif
								
							else
								'	return path is NULL
								MessageBox(hWin, "Invalid Temporay folder path", @"Info", MB_OK or MB_APPLMODAL)
								_ERROR_STAT = _ERROR_STAT or ERROR_NO_TEMPFOLDER
							endif
							
							'	Error Handling
							get_error_status()
							reflect_error_status()
	
						case IDM_MAKE_EXTRACT

							if (check_thread()) then exit select  
							
							ztemp = "Start the extract chunks texture data?" + !"\r\n" + "This process takes a long time."

							retval = MessageBox(hWin, ztemp, @"Extract chunks texture data", MB_YESNO or MB_APPLMODAL)
							if (retval <> IDYES) then exit select
							
							dim as any ptr handle
							handle = ThreadCreate(@extract_chunks_texture_data)
							ThreadDetach(handle)
						
						case IDM_MAKE_REBUILD
							
							if (check_thread()) then exit select  

							ztemp = "Temporary folder = " + _temppath + !"\r\n"
							ztemp += get_dds_settings() + !"\r\n"
							ztemp += "Replace textures and rebuild vpp_pc file?" + !"\r\n" + "This process takes a long time."
							
							retval = MessageBox(hWin, ztemp, @"Relace textures and rebuild", MB_YESNO or MB_APPLMODAL)
							if (retval <> IDYES) then exit select

							EnableMenuItem(_hMenu, IDM_MAKE_ABORT, MF_ENABLED)
						
							dim as any ptr handle
							handle = ThreadCreate(@replace_textures_and_rebuild)
							ThreadDetach(handle)
														
						case IDM_MAKE_STAT

							if (check_thread()) then exit select  
							
							retval = MessageBox(hWin, "Generate texture_statistics.txt?", @"Info", MB_YESNO or MB_APPLMODAL)
							if (retval<>IDYES) then exit select
							
							dim as any ptr handle
							handle = ThreadCreate(@make_texture_statistics)
							ThreadDetach(handle)
							
						case IDM_MAKE_ABORT

							EnableMenuItem(_hMenu, IDM_MAKE_ABORT, MF_GRAYED)
							DrawMenuBar(_hMenu)
							_THREAD_ABORT = TRUE
	
						case IDM_HELP_ABOUT
							
							DialogBoxParam(GetModuleHandle(NULL), Cast(zstring ptr,IDD_DLGABOUT), NULL, @AboutDlgProc, NULL)
							
						case else
					end select
				case else
			end select
			'
		case else

			return(FALSE)
			'
	end select

	return(TRUE)

end function

function main() as s32

	_currpath = curdir()
	_rootpath = exepath
	chdir(_rootpath)

	'	Create the Dialog
	_hInstance=GetModuleHandle(NULL)
	DialogBoxParam(_hInstance, cast(zstring ptr,IDD_DLG1), 0, @DialogProc, 0)

	'	Program has ended
	chdir(_currpath)
	ExitProcess(0)
	return(0)
end function

end( main() )

'----------------------------------------------------------
'	compare png image (same image return true)
'----------------------------------------------------------
function compare_image(srcfile as string, dstfile as string) as double
	dim as s32 src_w, src_h, dst_w, dst_h, bypp, diff_flag
	dim as u32 n, size

	dim srcimage(any) as u8
	dim dstimage(any) as u8
	
	libpng.load_png(srcfile, srcimage(), src_w, src_h, bypp)
	libpng.load_png(dstfile, dstimage(), dst_w, dst_h, bypp)

	if (src_w <> dst_w) then return(false)
	if (src_h <> dst_h) then return(false)

	size = src_w * src_h * 4

	diff_flag = true
	for n = 0 to size - 1
		if (srcimage(n) <> dstimage(n)) then
			diff_flag = false
			exit for
		endif
	next
	return(diff_flag)
end function

'----------------------------------------------------------
'	delete file (returns success:false fail:true)
'----------------------------------------------------------
function delete_file(destpath as string, attrib_mask as s32) as s32
	dim as string path, fname, dfname
	
	path = libfio.get_directory(destpath)
	fname = dir(destpath, attrib_mask)	
	do while (fname <> "")
		dfname = path + fname
		fname = dir()
		if (kill(dfname)) then return(true)
	loop
	return(false)
end function

'----------------------------------------------------------
'	copy file (returns success:false fail:true)
'----------------------------------------------------------
function copy_file(sourcepath as string, destpath as string, attrib_mask as s32) as s32
	dim as string spath, fname, sfname, dfname
	
	spath = libfio.get_directory(sourcepath)
	fname = dir(sourcepath, attrib_mask)
	do while (fname <> "")
		sfname = spath + fname
		dfname = destpath + "\" + fname
		fname = dir()
		if (filecopy(sfname, dfname)) then return(true)
	loop
	return(false)
end function

'----------------------------------------------------------
'	move one file (returns success:false fail:true)
'----------------------------------------------------------
function move_onefile(sourcepath as string, destpath as string) as s32
	if (filecopy(sourcepath, destpath)) then
		return(true)
	else
		if (kill(sourcepath)) then return(true)
	endif
	return(false)
end function

'----------------------------------------------------------
'	check drive existence
'----------------------------------------------------------
function drive_exist(path as string) as s32
	dim as s32 attrib_mask
	dim as string drivepath, retstr
	
	attrib_mask = fbDirectory or fbArchive or fbHidden or fbSystem
	drivepath = left(path, 2) + "\NUL"
	
	retstr = dir(drivepath, attrib_mask)
	if (retstr =  "NUL") then
		return(F_NOERROR)
	else
		return(F_ERROR)
	endif
end function

'----------------------------------------------------------
'	prepare temporary folders
'----------------------------------------------------------
function init_temporary_folder() as s32
	dim as s32 ret
	dim as string destpath
	dim as zstring*256 ztemp

	if (_temppath = "") then
		ztemp = !"temporary folder path is not set.\r\nPlease set temporary folder path."
		MessageBox(NULL, ztemp, @"Error", MB_OK)
		return(F_ERROR)
	else
		'	check drive existence
		if (mid(_temppath, 2, 1) = ":") then
			if (drive_exist(_temppath) = F_ERROR) then
				ztemp = "temporary folder drive " + left(_temppath, 2) + " not exist."
				MessageBox(NULL, ztemp, @"Error", MB_OK)
				return(F_ERROR)
			endif
		endif
		'	preparation for temporary folder
		if (dir(_temppath, fbDirectory) = "") then	'	folder not exist.
			'	make temporary folder
			ret = mkdir(_temppath)
			if (ret) then
				'	mkdir fail
				ztemp = "Error:can't make temporary folder " + _temppath
				MessageBox(NULL, ztemp, @"Error", MB_OK)
				return(F_ERROR)
			endif
		endif
		destpath = _temppath + _TEMP_CHUNKS
		if (dir(destpath, fbDirectory) = "") then mkdir(destpath)
		destpath = _temppath + _TEMP_DDS
		if (dir(destpath, fbDirectory) = "") then mkdir(destpath)
		destpath = _temppath + _TEMP_PEGS
		if (dir(destpath, fbDirectory) = "") then mkdir(destpath)
	endif
	return(F_NOERROR)	'	no error
end function

'--------------------------------------------------------------------
'	delete all temporary files
'--------------------------------------------------------------------
sub delete_temporary_files()
	dim as string destpath

	'	cleanup temporary chunks folder
	destpath = _temppath + _TEMP_CHUNKS + "\*.*"
	delete_file(destpath, fbArchive)
	'	cleanup temporary peg folder
	destpath = _temppath + _TEMP_PEGS + "\*.*"
	delete_file(destpath, fbArchive)
	'	cleanup temporary dds folder
	destpath = _temppath + _TEMP_DDS + "\*.*"
	delete_file(destpath, fbArchive)
	
end sub

'--------------------------------------------------------------------
'	delete temporary subfolders
'--------------------------------------------------------------------
sub delete_temporary_subfolders()
	dim as string destpath
	
	'	delete temporary chunks folder
	delete_temporary_files()
	destpath = _temppath + _TEMP_CHUNKS
	rmdir(destpath)
	'	delete temporary dds folder
	destpath = _temppath + _TEMP_DDS
	rmdir(destpath)
	'	delete temporary peg folder
	destpath = _temppath + _TEMP_PEGS
	rmdir(destpath)
end sub

'--------------------------------------------------------------------
'	when all vpp_pc files exist return F_NOERROR else return F_ERROR
'--------------------------------------------------------------------
function check_vpp_pc_files(path as string) as s32
	dim as string fpath
	
	fpath = path + "\chunks1.vpp_pc"
	if (dir(fpath, fbArchive) = "") then return(F_ERROR)

	fpath = path + "\chunks2.vpp_pc"
	if (dir(fpath, fbArchive) = "") then return(F_ERROR)

	fpath = path + "\chunks3.vpp_pc"
	if (dir(fpath, fbArchive) = "") then return(F_ERROR)

	fpath = path + "\pegs.vpp_pc"
	if (dir(fpath, fbArchive) = "") then return(F_ERROR)

	return(F_NOERROR)	
end function

'----------------------------------------------------------
'	get chunk names from list file
'	return total chunks number
'----------------------------------------------------------
function get_chunk_names_from_file(sourcefile as string) as s32
	dim as s32 ret, cn, n = 0, total = 0
	dim as string ename, value
	dim as zstring*256 ztemp
	
	ret = xml.read_doc(sourcefile)
	if (ret <> XML_NO_ERROR) then
		cprint using "ERROR:Can't open &"; sourcefile
		MessageBox(NULL, "Can't open " + sourcefile, @"Error", MB_OK)
		return(0)
	endif
	xml.read_element(ename, value)	' <ChunkNameList>
	if (ename <> "ChunkNameList") then
		ztemp = sourcefile + " is not chunknamelist file"
		MessageBox(NULL, ztemp, @"Error", MB_OK)
		xml.close_doc()
		return(0)
	endif
	xml.read_element(ename, value)	' <Entries>
	do
		' read 1 entry
		xml.read_element(ename, value)	' <Entry>
		select case ename
			case "Entry"
				xml.read_element(ename, value)	' <Name>chunks*</Name>
				n = 0
				select case value
					case "chunks1"
						cn = 0
					case "chunks2"
						cn = 1
					case "chunks3"
						cn = 2
					case else
				end select
				xml.read_element(ename, value)	' <Chunks>
				do
					xml.read_element(ename, value)	' <Chunk>***</Chunk> or </Entry>
					select case ename
						case "Chunk"
							_chunks(cn).chunk(n).name = value
							_chunks(cn).chunk(n).replaceflag = false
							n+=1
							if (n > MAX_CHUNKS) then
								cprint using "ERROR:Some syntax error found in &"; sourcefile
								MessageBox(NULL, "Some syntax error found in " + sourcefile, @"Error", MB_OK)
								xml.close_doc()
								return(0)
							endif
						case "/Chunks"
							_chunks(cn).num = n
							total+=n
						case "/Entry"
							exit do
						case else
					end select
				loop
			case "/Entries"
				exit do
			case else
		end select
	loop

	xml.close_doc()

	return(total)

end function

'----------------------------------------------------------
'	get chunk names in chunks1\, chunks2\, chunks3\
'	return total chunks number 
'----------------------------------------------------------
function get_chunk_names() as s32
	dim as s32 i, n, total
	dim as string path, retstr

	total = 0
	for i = 0 to 2

		select case i
			case 0
				path = "chunks1\sr2*"
			case 1
				path = "chunks2\sr2*"
			case 2
				path = "chunks3\sr2*"
			case else
		end select
	
		n = 0
		retstr = dir(path, fbDirectory)
		if (retstr <> "") then		' there's a file
			_chunks(i).chunk(n).name = libfio.get_filename_only(retstr)
			_chunks(i).chunk(n).replaceflag = false
			n+=1
			do 
				retstr = dir()		' dir() returns next filename
				if (retstr <> "") then
					_chunks(i).chunk(n).name = libfio.get_filename_only(retstr)
					_chunks(i).chunk(n).replaceflag = false
					n+=1
				else
					_chunks(i).num = n	' total number in _chunks(i)
					exit do
				endif
			loop while (1)
		else
			' there's no file
			_chunks(i).num = n		' total number in _chunks(i) is 0	(error)
		endif
		total += n
	next
	
	return(total)

end function

'--------------------------------------------------------------------
'	get image colour as string
'--------------------------------------------------------------------
function get_image_colour_string(n as s32) as string
	select case n
		case DDS_sRGB_COLOUR
			return("sRGB")
		case DDS_LINEAR_COLOUR
			return("LINEAR")
		case else
			return("Undefined")
	end select
end function

'----------------------------------------------------------
'	display settings list (0:path settings, 1:dds settings
'----------------------------------------------------------
function get_dds_settings() as string
	dim as string filter, image_colour, stemp

	filter = dds.dds_director.mipmap(DDS_MIPMAP_DXT1).resize_filter
	image_colour = get_image_colour_string(dds.dds_director.mipmap(DDS_MIPMAP_DXT1).colourspace)
	stemp += "DXT1, " + filter + ", " + image_colour + !"\r\n"

	filter = dds.dds_director.mipmap(DDS_MIPMAP_DXT3_DXT5).resize_filter
	image_colour = get_image_colour_string(dds.dds_director.mipmap(DDS_MIPMAP_DXT3_DXT5).colourspace)
	stemp += "DXT3/5, " + filter + ", " + image_colour + !"\r\n"

	filter = dds.dds_director.mipmap(DDS_MIPMAP_NORMALMAP).resize_filter
	image_colour = get_image_colour_string(dds.dds_director.mipmap(DDS_MIPMAP_NORMALMAP).colourspace)
	stemp += "Normalmap, " + filter + ", " + image_colour + !"\r\n"

	return(stemp)
end function

'--------------------------------------------------------------------
'	display message to listbox and stack it
'--------------------------------------------------------------------
sub AddMessage(byref zst as zstring)
	dim as s32 ln
	ln = SendMessage(GetDlgItem(_hDlg, IDC_LST1), LB_ADDSTRING, 0, cast(LPARAM, @zst))
	UpdateWindow(GetDlgItem(_hDlg, IDC_LST1))
	_ListStack(_StackDepth).n = ln
	_ListStack(_StackDepth).message = zst
	_StackDepth += 1
end sub

'--------------------------------------------------------------------
'	delete stack message from listbox
'--------------------------------------------------------------------
sub DelMessage(byref zst as zstring)
	dim as s32 ln, i
	select case zst
		case ""
			if (_StackDepth > 0) then
				_StackDepth -= 1
				ln = _ListStack(_StackDepth).n
				SendMessage(GetDlgItem(_hDlg, IDC_LST1), LB_DELETESTRING, ln, 0)
				UpdateWindow(GetDlgItem(_hDlg, IDC_LST1))
				_ListStack(_StackDepth).n = 0
				_ListStack(_StackDepth).message = ""
			endif
		case "*"
			for i = _StackDepth - 1 to 0 step -1
				ln = _ListStack(i).n
				SendMessage(GetDlgItem(_hDlg, IDC_LST1), LB_DELETESTRING, ln, 0)
				UpdateWindow(GetDlgItem(_hDlg, IDC_LST1))
				_ListStack(_StackDepth).n = 0
				_ListStack(_StackDepth).message = ""
			next
		case else
			ln = SendMessage(GetDlgItem(_hDlg, IDC_LST1), LB_FINDSTRING, 0, cast(LPARAM, @zst))
			if (ln <> -1) then
				SendMessage(GetDlgItem(_hDlg, IDC_LST1), LB_DELETESTRING, ln, 0)
				for i = ln to _StackDepth - 2
					_ListStack(i) = _ListStack(i+1)			
				next
				_StackDepth -= 1
				_ListStack(_StackDepth).n = 0
				_ListStack(_StackDepth).message = ""			
			endif	
	end select
end sub

'--------------------------------------------------------------------
'	get error status and set flag to _ERROR_STAT
'--------------------------------------------------------------------
sub get_error_status()
	
	dim as s32 retval
	
	'	check SR2 installed folder path
	if (_sr2path = "") then
		_ERROR_STAT = _ERROR_STAT or ERROR_NO_SR2FOLDER
	else
		if (dir(_sr2path + "\chunks1.vpp_pc", fbArchive) = "") then
			_ERROR_STAT = _ERROR_STAT or ERROR_NO_SR2FOLDER
		else
			_ERROR_STAT = _ERROR_STAT and (not ERROR_NO_SR2FOLDER)
		endif				
	endif
	
	'	check temporary folder setting
	retval = init_temporary_folder()
	if (retval = F_ERROR) then
		_ERROR_STAT = _ERROR_STAT or ERROR_NO_TEMPFOLDER
	else
		_ERROR_STAT = _ERROR_STAT and (not ERROR_NO_TEMPFOLDER)
	endif

	'	check original_vpp_pc
	retval = check_vpp_pc_files(_ORIGINAL_VPP_PC)
	if (retval = F_ERROR) then
		_ERROR_STAT = _ERROR_STAT or ERROR_NO_VPPSOURCE
	else
		_ERROR_STAT = _ERROR_STAT and (not ERROR_NO_VPPSOURCE)
	endif
		
	'	get chunk number and names
	_total_chunks = get_chunk_names()
	if (_total_chunks <> _TOTAL_CHUNKS_NUMBER) then
		_ERROR_STAT = _ERROR_STAT or ERROR_NO_CHUNKSDATA
	else
		_ERROR_STAT = _ERROR_STAT and (not ERROR_NO_CHUNKSDATA)
	endif

	'	check new_vpp_pc
	retval = check_vpp_pc_files(_REBUILD_VPP_PC)
	if (retval = F_ERROR) then
		_ERROR_STAT = _ERROR_STAT or ERROR_NO_VPPNEW
	else
		_ERROR_STAT = _ERROR_STAT and (not ERROR_NO_VPPNEW)
	endif
		
end sub

'--------------------------------------------------------------------
'	reflect error flag in _ERROR_STAT to display message
'	and Enable/Disable menu
'--------------------------------------------------------------------
sub reflect_error_status()

	dim as s32 flag, n, retval

	'	List Error Messages
	DelMessage("*")

	if (_ERROR_STAT = 0 or (_ERROR_STAT = ERROR_NO_VPPNEW)) then
		AddMessage("Ready.")	'	No Error
	else
		flag = FALSE
		n = 1
		do while (n < ERROR_MAXVAL)
			retval = _ERROR_STAT and n
			if (retval <> 0) then
				flag = TRUE
				select case n
					case ERROR_WRONG_INIFILE
						AddMessage("Wrong ini file description.")
					case ERROR_NO_SR2FOLDER
						AddMessage("Valid SR2 installed folder not set.")
					case ERROR_NO_TEMPFOLDER
						AddMessage("Temporary folder not set.")
					case ERROR_NO_VPPSOURCE
						AddMessage("No original vpp_pc files.")
					case ERROR_NO_CHUNKSDATA
						AddMessage("No chunks texture data.")
					case else
				end select
			endif
			n*=2
		loop
	endif

	'	Redraw	Menu			
	if (_ERROR_STAT and ERROR_NO_SR2FOLDER) then	'	Invalid SR2 install folder

		EnableMenuItem(_hMenu, IDM_FILE_COPY, MF_GRAYED)
		DrawMenuBar(_hMenu)

	else

		if (_ERROR_STAT and ERROR_NO_VPPNEW) then	'	There's no new vpp_pc files
			EnableMenuItem(_hMenu, IDM_FILE_COPY, MF_GRAYED)
		else
			EnableMenuItem(_hMenu, IDM_FILE_COPY, MF_ENABLED)
		endif
		DrawMenuBar(_hMenu)

	endif
	
	if (_ERROR_STAT and ERROR_NO_TEMPFOLDER) then	'	Invalid temp folder

		EnableMenuItem(_hMenu, IDM_MAKE_EXTRACT, MF_GRAYED)
		EnableMenuItem(_hMenu, IDM_MAKE_REBUILD, MF_GRAYED)
		DrawMenuBar(_hMenu)

	else

		if (_ERROR_STAT and ERROR_NO_VPPSOURCE) then	'	There's no original vpp_pc files
			EnableMenuItem(_hMenu, IDM_MAKE_EXTRACT, MF_GRAYED)
		else
			EnableMenuItem(_hMenu, IDM_MAKE_EXTRACT, MF_ENABLED)
		endif
		DrawMenuBar(_hMenu)

		if (_ERROR_STAT and ERROR_NO_CHUNKSDATA) then	'	There's no chunks texture data
			EnableMenuItem(_hMenu, IDM_MAKE_REBUILD, MF_GRAYED)
			EnableMenuItem(_hMenu, IDM_MAKE_STAT, MF_GRAYED)
			EnableMenuItem(_hMenu, IDM_FILE_INIT, MF_GRAYED)
		else
			EnableMenuItem(_hMenu, IDM_MAKE_REBUILD, MF_ENABLED)
			EnableMenuItem(_hMenu, IDM_MAKE_STAT, MF_ENABLED)
			EnableMenuItem(_hMenu, IDM_FILE_INIT, MF_ENABLED)			
		endif
		DrawMenuBar(_hMenu)

	endif
		
end sub

'----------------------------------------------------------
'	abort thread
'----------------------------------------------------------
sub abort_thread()

	AddMessage("Aborting Process...")

	delete_temporary_files()

	MessageBox(_hDlg, "Process aborted.", @"Info", MB_OK or MB_APPLMODAL)

	'	reset progress bar
	_Progress_Val = 0
	SendMessage(_hProg, PBM_SETPOS, _Progress_Val, 0)
	display_time()

	'	clear messages
	DelMessage("")

	'	Make-Abort menu Grayed out
	EnableMenuItem(_hMenu, IDM_MAKE_ABORT, MF_GRAYED)
	DrawMenuBar(_hMenu)

	'	error handling
	get_error_status()
	reflect_error_status()

	'	thread status
	_THREAD_STATUS = THREAD_NOT_IN_USE
	_THREAD_ABORT = FALSE
	
end sub

'----------------------------------------------------------
'	check thread status
'	when other thread working this function return TRUE
'----------------------------------------------------------
function check_thread() as s32
	
	if (_THREAD_STATUS = THREAD_IN_USE) then
		MessageBox(_hDlg, "This item cannot be selected until the current processing is completed.", @"Info", MB_OK or MB_APPLMODAL)
		return(TRUE)
	else
		return(FALSE)
	endif
	
end function


'--------------------------------------------------------------------
'	Display Elapsed Time and Remaining Time. Use with Progress Bar
'--------------------------------------------------------------------
sub display_time()
	dim as s32 ln
	static as double start_time
	dim as double percent, current_time, elapsed_time, remain_time
	dim as string remain_time_str
	dim as zstring*260 ztemp

	if (_Progress_Val = 0) then
		start_time = timer
		ztemp = "Elapsed Time"
		ln = SendMessage(GetDlgItem(_hDlg, IDC_LST2), LB_GETCOUNT, 0, 0)
		if (ln > 0) then
			SendMessage(GetDlgItem(_hDlg, IDC_LST2), LB_DELETESTRING, 0, 0)
			UpdateWindow(GetDlgItem(_hDlg, IDC_LST2))
		endif
	else
		ln = SendMessage(GetDlgItem(_hDlg, IDC_LST2), LB_GETCOUNT, 0, 0)
		if (ln > 0) then
			SendMessage(GetDlgItem(_hDlg, IDC_LST2), LB_DELETESTRING, 0, 0)
		endif
		percent = _Progress_Val/_Progress_Max
		current_time = timer
		elapsed_time = (current_time - start_time) * 1.0/percent
		_elapsed_time_str = libstr.format_hms(current_time - start_time)
		remain_time = cint(elapsed_time - (current_time - start_time))
		remain_time_str = libstr.format_hms(remain_time)
		ztemp = "Elapsed Time " + _elapsed_time_str + "    Remaining Time " + remain_time_str
		SendMessage(GetDlgItem(_hDlg, IDC_LST2), LB_ADDSTRING, 0, cast(LPARAM, @ztemp))
		UpdateWindow(GetDlgItem(_hDlg, IDC_LST2))
	endif
end sub

'--------------------------------------------------------------------
'	copy original *.vpp_pc files to original_vpp_pc folder
'--------------------------------------------------------------------
sub copy_vpp_pc_sourcefiles()
	dim as string sourcepath, destpath
	dim as s32 retval, ln
	
	_THREAD_STATUS = THREAD_IN_USE
	_THREAD_RETURN = F_NOERROR

	_Progress_Val = 0
	_Progress_Max = 3
	SendMessage(_hProg, PBM_SETRANGE, 0, MAKELPARAM( 0, _Progress_Max ))
	SendMessage(_hProg, PBM_SETPOS, _Progress_Val, 0)

	sourcepath = _sr2path + "\chunks1.vpp_pc"
	destpath = _ORIGINAL_VPP_PC
	AddMessage("Copying chunks1.vpp_pc...")
	copy_file(sourcepath, destpath, fbArchive)
	
	_Progress_Val+=1
	SendMessage(_hProg, PBM_SETPOS, _Progress_Val, 0)
	
	sourcepath = _sr2path + "\chunks2.vpp_pc"
	destpath = _ORIGINAL_VPP_PC
	AddMessage("Copying chunks2.vpp_pc...")
	copy_file(sourcepath, destpath, fbArchive)

	_Progress_Val+=1
	SendMessage(_hProg, PBM_SETPOS, _Progress_Val, 0)

	sourcepath = _sr2path + "\chunks3.vpp_pc"
	destpath = _ORIGINAL_VPP_PC
	AddMessage("Copying chunks3.vpp_pc...")
	copy_file(sourcepath, destpath, fbArchive)
	
	_Progress_Val+=1
	SendMessage(_hProg, PBM_SETPOS, _Progress_Val, 0)
	
	sourcepath = _sr2path + "\pegs.vpp_pc"
	destpath = _ORIGINAL_VPP_PC
	AddMessage("Copying pegs.vpp_pc...")
	copy_file(sourcepath, destpath, fbArchive)

	_Progress_Val+=1
	SendMessage(_hProg, PBM_SETPOS, _Progress_Val, 0)

	MessageBox(_hDlg, "Original vpp_pc files was copied to the original_vpp_pc folder.", @"Info", MB_OK or MB_APPLMODAL)

	'	clear message
	DelMessage("")
	DelMessage("")
	DelMessage("")
	DelMessage("")
	
	'	Error handling
	get_error_status()
	reflect_error_status()
		
	'	reset progress bar
	_Progress_Val = 0
	SendMessage(_hProg, PBM_SETPOS, _Progress_Val, 0)
	
	_THREAD_STATUS = THREAD_NOT_IN_USE
	_THREAD_RETURN = F_NOERROR

end sub

'--------------------------------------------------------------------
'	copy new *.vpp_pc files to SR2 installed folder
'--------------------------------------------------------------------
sub copy_vpp_pc_newfiles()
	dim as string sourcepath, destpath
	dim as zstring*260 ztemp
	dim as s32 retval, ln
	
	_THREAD_STATUS = THREAD_IN_USE
	_THREAD_RETURN = F_NOERROR
	
	_Progress_Val = 0
	_Progress_Max = 3
	SendMessage(_hProg, PBM_SETRANGE, 0, MAKELPARAM( 0, _Progress_Max ))
	SendMessage(_hProg, PBM_SETPOS, _Progress_Val, 0)

	retval = check_vpp_pc_files(_REBUILD_VPP_PC)
	if (retval = F_ERROR) then
		_THREAD_STATUS = THREAD_NOT_IN_USE
		_THREAD_RETURN = F_ERROR
		return
	EndIf
	
	sourcepath = _REBUILD_VPP_PC + "\chunks1.vpp_pc"
	destpath = _sr2path
	AddMessage("Copying chunks1.vpp_pc...") 
	copy_file(sourcepath, destpath, fbArchive)
	
	_Progress_Val+=1
	SendMessage(_hProg, PBM_SETPOS, _Progress_Val, 0)
	
	sourcepath = _REBUILD_VPP_PC + "\chunks2.vpp_pc"
	destpath = _sr2path
	AddMessage("Copying chunks2.vpp_pc...")
	copy_file(sourcepath, destpath, fbArchive)

	_Progress_Val+=1
	SendMessage(_hProg, PBM_SETPOS, _Progress_Val, 0)

	sourcepath = _REBUILD_VPP_PC + "\chunks3.vpp_pc"
	destpath = _sr2path
	AddMessage("Copying chunks3.vpp_pc...")
	copy_file(sourcepath, destpath, fbArchive)
	
	_Progress_Val+=1
	SendMessage(_hProg, PBM_SETPOS, _Progress_Val, 0)
	
	sourcepath = _REBUILD_VPP_PC + "\pegs.vpp_pc"
	destpath = _sr2path
	AddMessage("Copying pegs.vpp_pc...")
	copy_file(sourcepath, destpath, fbArchive)

	_Progress_Val+=1
	SendMessage(_hProg, PBM_SETPOS, _Progress_Val, 0)

	MessageBox(_hDlg, "The new files was copied successfully.", @"Info", MB_OK or MB_APPLMODAL)

	DelMessage("")
	DelMessage("")
	DelMessage("")
	DelMessage("")

	'	reset progress bar
	_Progress_Val = 0
	SendMessage(_hProg, PBM_SETPOS, _Progress_Val, 0)
	
	_THREAD_STATUS = THREAD_NOT_IN_USE
	_THREAD_RETURN = F_NOERROR
end sub

'----------------------------------------------------------
'	get textures in trash folder and return total number
'----------------------------------------------------------
function get_trash_textures() as s32
	dim as s32 attrib_mask, n
	dim as string path, retstr
	
	path = "new_textures\trash\*.png"
	
	attrib_mask = fbArchive
	n = 0
	retstr = dir(path, attrib_mask)
	if (retstr <> "") then
		_textures(n).name = retstr
		_textures(n).replaceflag = false
		n+=1
	else
		return(n)
	endif

	do 
		retstr = dir()
		if (retstr <> "") then
			_textures(n).name = retstr
			_textures(n).replaceflag = false
			n+=1
		else
			exit do
		endif
	loop while (TRUE)
	
	return(n)
	
end function

'----------------------------------------------------------
'	get new textures name and return total number 
'----------------------------------------------------------
function get_new_textures() as s32
	dim as s32 attrib_mask, n
	dim as string path, retstr
	
	path = "new_textures\*.png"
	
	attrib_mask = fbArchive
	n = 0
	retstr = dir(path, attrib_mask)
	if (retstr <> "") then
		_textures(n).name = retstr
		_textures(n).replaceflag = false
		n+=1
	else
		return(n)
	endif

	do 
		retstr = dir()
		if (retstr <> "") then
			_textures(n).name = retstr
			_textures(n).replaceflag = false
			n+=1
		else
			exit do
		endif
	loop while (TRUE)
	
	return(n)

end function

'----------------------------------------------------------
'	restore original texture
'----------------------------------------------------------
function restore_original_textures(texn as s32) as s32
	dim as s32 attrib_mask, cn, i, j, k, n, ctexn, cx, cy, ret
	dim as s32 processed_chunks, progress_percent
	dim as string filespec, path, chunkpath, texpath, ddstexpath, sourcepath, destpath
	dim as string sourcename, destname, argstring, retstr
	
	attrib_mask = fbArchive

	for cn = 0 to 2

		select case cn
			case 0
				path = "chunks1\"
			case 1
				path = "chunks2\"
			case 2
				path = "chunks3\"
			case else			
		end select
	
		'	replace texture images
		for i = 0 to _chunks(cn).num - 1

			'	search textures and revert to original
			for j = 0 to texn - 1
				texpath = path + _chunks(cn).chunk(i).name + "\" + _textures(j).name
				ddstexpath = libfio.change_filename_ext(texpath, ".dds")
				if (fileexists(texpath)) then	' same texture found
					sourcepath = libfio.change_filename_ext(texpath, "(org).png")
					destpath = texpath
					if (fileexists(sourcepath)) then	'	check (org).png file existence
						'	delete replaced png and dds
						kill(texpath)
						kill(ddstexpath)
						'	revert to original
						sourcepath = libfio.change_filename_ext(texpath, "(org).png")
						destpath = texpath
						name(sourcepath, texpath)	'	<texturename>(org).png -> texturename.png
						sourcepath = libfio.change_filename_ext(texpath, "(org).dds")
						destpath = ddstexpath
						name(sourcepath, destpath)	'	<texturename>(org).dds -> texturename.dds
						'	set rebuild flag
						_chunks(cn).chunk(i).replaceflag = true
					endif
				endif
			next j
		next i
	next cn

	for i = 0 to texn - 1
		sourcepath = "new_textures\trash\" + _textures(i).name
		destpath = "new_textures\trash\recycled\" + _textures(i).name
		ret = move_onefile(sourcepath, destpath)
		if (ret) then return(F_ERROR)
	next i

	return(F_NOERROR)
	
end function

'----------------------------------------------------------
'	replace texture in each chunk and rebuild g_peg_pc/peg_pc
'----------------------------------------------------------
function replace_textures(cn as s32, texn as s32) as s32
	static as s32 processed_chunks = 0
	dim as s32 attrib_mask, i, j, k, n, ctexn, orgtexn, cx, cy, ret
	dim as string filespec, path, chunkpath, texpath, ddstexpath
	dim as string chunk_temppath, peg_temppath, dds_temppath, renamepath, newtexpath, sourcepath, destpath
	dim as string sourcename, destname, argstring, retstr
	dim as string currtex(800)
	dim as zstring*256 ztemp

	attrib_mask = fbArchive
	
	select case cn
		case 0
			path = "chunks1\"
		case 1
			path = "chunks2\"
		case 2
			path = "chunks3\"
		case else			
	end select

	peg_temppath = _temppath + _TEMP_CHUNKS + "\"
	dds_temppath = _temppath + _TEMP_DDS + "\"

	'	replace texture images
	for i = 0 to _chunks(cn).num - 1
		'               012345678901234567890123456789
		'cprint using "> \                            \ replacing textures..."; _chunks(cn).chunk(i).name;
		'ztemp = libstr.strform_str("Left", 30, _chunks(cn).chunk(i).name) + " replacing textures..."
		ztemp = libstr.strform_str("Left", 30, _chunks(cn).chunk(i).name) + " replacing textures..."
		AddMessage(ztemp)

		chunkpath = path + _chunks(cn).chunk(i).name + "\"
		filespec = chunkpath + "*.png"

		'	get existence texture names in the chunk
		ctexn = 0
		retstr = dir(filespec, attrib_mask)
		do while retstr <> ""
			currtex(ctexn) = retstr
			ctexn+=1
			retstr = dir()
		loop

		'	search textures and replace to new one
		for j = 0 to ctexn - 1
			for k = 0 to texn - 1
				if (currtex(j) = _textures(k).name) then		'	same name file found
					_chunks(cn).chunk(i).replaceflag = true	'	set replaceflag
					texpath = path + _chunks(cn).chunk(i).name + "\" + _textures(k).name
					newtexpath = "new_textures\" + _textures(k).name

					ret = compare_image(texpath, newtexpath)
					if (not(ret)) then 								'	new texture is different from existing one

						ddstexpath = libfio.change_filename_ext(texpath, ".dds")

						'	backup original texture as texturename(org).png when texturename(org).png is not exist.
						renamepath = libfio.change_filename_ext(texpath, "(org).png")
						if (not(fileexists(renamepath))) then
							name(texpath, renamepath)
						end if

						'	backup original texture as texturename(org).dds when texturename(org).dds is not exist.
						renamepath = libfio.change_filename_ext(texpath, "(org).dds")
						if (not(fileexists(renamepath))) then
							name(ddstexpath, renamepath)
						else
							'	delete dds file
							kill(ddstexpath)
						end if
	
						'	replace png texture image file
						filecopy(newtexpath, texpath)
						
						'	set replace flag 
						if (_textures(k).replaceflag = false) then
							'	set flag
							_textures(k).replaceflag = true
							'	store replaced texture index
							_replaced(_replacedn).index = k
							_replacedn+=1
						else
							'	copy already converted dds file
							sourcepath = dds_temppath + _textures(k).name
							sourcepath = libfio.change_filename_ext(sourcepath, ".dds")
							destpath = libfio.change_filename_ext(texpath, ".dds")
							filecopy(sourcepath, destpath)
						endif
					else
						'	new texture is same to original one
						if (_textures(k).replaceflag = false) then	'	the new texture not converted yet
							ddstexpath = libfio.change_filename_ext(texpath, ".dds")
							'	backup original texture as texturename(org).png when texturename(org).png is not exist.
							renamepath = libfio.change_filename_ext(texpath, "(org).png")
							if (not(fileexists(renamepath))) then
								name(texpath, renamepath)
								filecopy(newtexpath, texpath)
							end if
							'	backup original texture as texturename(org).dds when texturename(org).dds is not exist.
							renamepath = libfio.change_filename_ext(texpath, "(org).dds")
							if (not(fileexists(renamepath))) then
								name(ddstexpath, renamepath)
							else
								'	delete dds file
								kill(ddstexpath)
							end if
							_textures(k).replaceflag = true
							'	store replaced texture index
							_replaced(_replacedn).index = k
							_replacedn+=1
						else
							'	copy already converted dds file
							sourcepath = dds_temppath + _textures(k).name
							sourcepath = libfio.change_filename_ext(sourcepath, ".dds")
							destpath = libfio.change_filename_ext(texpath, ".dds")
							ret = filecopy(sourcepath, destpath)
							if (ret) then
								'cprint using "can't copy file &."; _textures(k).name + ".dds"
								return(true)
							endif
						endif
					endif
				endif
			next k
		next j

		DelMessage(ztemp)

		if (_chunks(cn).chunk(i).replaceflag = true) then
			

			'	get *(org).png number
			filespec = chunkpath + "*(org).png"
			orgtexn = 0
			retstr = dir(filespec, attrib_mask)
			do while retstr <> ""
				orgtexn+=1
				retstr = dir()
			loop		

			'	get peg_desc filename to rebuild peg_pc and gpeg_pc
			sourcename = path + _chunks(cn).chunk(i).name + "\" + _chunks(cn).chunk(i).name + ".peg_desc"
			
			'	rebuild peg_pc and gpeg_pc
			'               012345678901234567890123456789
			'cprint using "> \                            \ rebuilding... entrycount:####"; _chunks(cn).chunk(i).name; ctexn - orgtexn;
			ztemp = libstr.strform_str("Left", 30, _chunks(cn).chunk(i).name) + " rebuilding... entrycount:" + libstr.strform_val(" ", 4, 0, ctexn - orgtexn)
			AddMessage(ztemp)
			n = peg_pc.rebuild_peg(sourcename, peg_temppath)
			if (n = F_ERROR) then
				ztemp = "Fail to rebuild " + _chunks(cn).chunk(i).name
				MessageBox(NULL, ztemp, @"Error", MB_OK)
				return(F_ERROR)
			endif
			DelMessage("")						

			'	move .peg_pc file
			sourcepath = peg_temppath + _chunks(cn).chunk(i).name + ".peg_pc"
			destpath = _temppath + _TEMP_PEGS + "\" + _chunks(cn).chunk(i).name + ".peg_pc"
			ret = move_onefile(sourcepath, destpath)
			if (ret) then
				ztemp = "can't move file " + _chunks(cn).chunk(i).name + ".peg_pc"
				MessageBox(NULL, ztemp, @"Error", MB_OK)
				return(F_ERROR)
			endif
			
			'	copy new dds file to temporary folder
			for j = _processed_textures to _replacedn - 1
				sourcepath = path + _chunks(cn).chunk(i).name + "\" + _textures(_replaced(j).index).name
				sourcepath = libfio.change_filename_ext(sourcepath, ".dds")
				destpath = dds_temppath + _textures(_replaced(j).index).name
				destpath = libfio.change_filename_ext(destpath, ".dds")
				filecopy(sourcepath, destpath)
			next
			_processed_textures = _replacedn
		endif

		'	progress bar
		_Progress_Val +=1
		SendMessage(_hProg, PBM_SETPOS, _Progress_Val, 0)
		display_time()

		if (_THREAD_ABORT = TRUE) then
			return(F_ERROR)
		endif

	next i
	
	return(F_NOERROR)
	
end function

'----------------------------------------------------------
'	replace texture and rebuild vpp_pc
'----------------------------------------------------------
sub replace_textures_and_rebuild()
	dim as s32 i, n, texn, ret
	dim as string kstr, sourcepath, destpath, cmdstring, resize_method
	dim as zstring*256 ztemp

	_THREAD_STATUS = THREAD_IN_USE
	_THREAD_RETURN = F_NOERROR
	_THREAD_ABORT = FALSE

	AddMessage("Replace textures and rebuid vpp_pc files.")

	delete_temporary_files()

	'	processing texture replacement
	AddMessage("Gathering file infomation...")
	
	'	get chunk names and total number
	_total_chunks = get_chunk_names()
	
	'------------------------------------------------------
	'	restore original texture when trash folder is not empty
	'------------------------------------------------------
	' get textures in trash folder
	texn = get_trash_textures()
	DelMessage("")
	
	if (texn < 1) then
		'	nop
	else
		AddMessage("Restoring original textures...")
		'	restore original textures.
		ret = restore_original_textures(texn)
		if (ret) then
			MessageBox(NULL, "restoring original textures failed", @"Error", MB_OK)
			_THREAD_RETURN = ret
			_THREAD_STATUS = THREAD_NOT_IN_USE
			return
		else
			DelMessage("")
		endif
	endif

	'	init progressbar
	_Progress_Val = 0
	_Progress_Max = _total_chunks + 3
	SendMessage(_hProg, PBM_SETRANGE, 0, MAKELPARAM(0, _Progress_Max))
	SendMessage(_hProg, PBM_SETPOS, _Progress_Val, 0)
	display_time()

	'	get new textures
	texn = get_new_textures()
	
	'		extract original peg files to temp folder
	if (_THREAD_ABORT = TRUE) then
		abort_thread()
		return
	endif
	
	AddMessage("Extracting pegs.vpp_pc files to temporary folder...")

	sourcepath = _ORIGINAL_VPP_PC + "\pegs.vpp_pc"
	destpath = _temppath + _TEMP_PEGS
	SaintsRow2_FileFormats.UnpackFile(sourcepath, destpath)

	DelMessage("")
	
'	progress_bar
	_Progress_Val+=1
	SendMessage(_hProg, PBM_SETPOS, _Progress_Val, 0)
	display_time()
	
	' ------------------------------------
	' 	chunks
	' ------------------------------------
	'	replace chunks1, 2, 3 textures and rebuild g_peg_pc and peg_pc.
	for i = 0 to 2
	
		'	extract original chunks data to temporary folder
		if (_THREAD_ABORT = TRUE) then
			abort_thread()
			return
		endif

		ztemp = "Extracting chunks" + libstr.strform_val(" ", 1, 0, i + 1) + ".vpp__pc file to temporary folder..."
		AddMessage(ztemp)
		select case i
			case 0
				sourcepath = _ORIGINAL_VPP_PC + "\chunks1.vpp_pc"
			case 1
				sourcepath = _ORIGINAL_VPP_PC + "\chunks2.vpp_pc"
			case 2
				sourcepath = _ORIGINAL_VPP_PC + "\chunks3.vpp_pc"
			case else
		end select
		
		destpath = _temppath + _TEMP_CHUNKS
		SaintsRow2_Fileformats.UnpackFile(sourcepath, destpath)
		DelMessage("")
		
		'	replace textures and rebuid new gpeg_pc and peg_pc
		ret = replace_textures(i, texn)

		if (ret = F_ERROR) then
			abort_thread()
			return
		endif

		'	_chunks(i) g_peg_pc
		'cprint using "> building chunks#.vpp__pc..."; i + 1;

		if (_THREAD_ABORT = TRUE) then
			abort_thread()
			return
		endif

		ztemp = "Building chunks" + libstr.strform_val(" ", 1, 0, i + 1) + ".vpp__pc..."
		AddMessage(ztemp)	
		'		re-package chunks.vpp_pc
		sourcepath = _temppath + _TEMP_CHUNKS
		select case i
			case 0
				destpath = _REBUILD_VPP_PC + "\chunks1.vpp_pc"
			case 1
				destpath = _REBUILD_VPP_PC + "\chunks2.vpp_pc"
			case 2
				destpath = _REBUILD_VPP_PC + "\chunks3.vpp_pc"
			case else
		end select

		SaintsRow2_FileFormats.PackFile(sourcepath, destpath)

		DelMessage("")

		if (_THREAD_ABORT = TRUE) then
			abort_thread()
			return
		endif

		'		cleanup temporary chunks folder
		destpath = _temppath + _TEMP_CHUNKS + "\*.*"
		delete_file(destpath, FbArchive)
	next

	' ------------------------------------
	' 	pegs
	' ------------------------------------

	if (_THREAD_ABORT = TRUE) then
		abort_thread()
		return
	endif

	AddMessage("Building pegs.vpp_pc...")
	
	'		re-package pegs.vpp_pc
	sourcepath = _temppath + _TEMP_PEGS
	destpath = _REBUILD_VPP_PC + "\pegs.vpp_pc"
	SaintsRow2_FileFormats.PackFile(sourcepath, destpath)
	DelMessage("")

	_Progress_Val+=1
	SendMessage(_hProg, PBM_SETPOS, _Progress_Val, 0)
	display_time()

	'		cleanup peg temporary files
	AddMessage("Delete temporary files...")

	destpath = _temppath + _TEMP_PEGS + "\*.*"
	delete_file(destpath, FbArchive)

	'	cleanup temporary dds folder
	destpath = _temppath + _TEMP_DDS + "\*.*"
	delete_file(destpath, FbArchive)

	DelMessage("")

	'	progress 100%
	_Progress_Val+=1
	SendMessage(_hProg, PBM_SETPOS, _Progress_Val, 0)
	display_time()

	ztemp = "Replace textures and rebuild vpp_pc files was completed successfully." + !"\r\n" + "Processing time is " + _elapsed_time_str
	MessageBox(_hDlg, ztemp, @"Info", MB_OK or MB_APPLMODAL)

	'	error handling
	get_error_status()
	reflect_error_status()

	'	reset progress bar
	_Progress_Val = 0
	SendMessage(_hProg, PBM_SETPOS, _Progress_Val, 0)
	display_time()

	'	Make-Abort menu Grayed out
	EnableMenuItem(_hMenu, IDM_MAKE_ABORT, MF_GRAYED)
	DrawMenuBar(_hMenu)

	_THREAD_STATUS = THREAD_NOT_IN_USE
	_THREAD_ABORT = FALSE

end sub

'----------------------------------------------------------
'	extract all chunks texture data
'----------------------------------------------------------
sub extract_chunks_texture_data()
	dim as s32 i, j, n, texn, ret
	dim as s32 ln, ln2
	dim as string sourcepath, destpath, cmdstring, resize_method
	dim as zstring*256 ztemp

	_THREAD_STATUS = THREAD_IN_USE
	_THREAD_RETURN = F_NOERROR
	
	AddMessage("Extract chunks1, chunks2, chunks3 texture data.")

	delete_temporary_files()

	'------------------------------------------------------
	'	create chunks1, chunks2, chunks3 data
	'------------------------------------------------------
	'		extract original peg files to temp folder

	sourcepath = "chunkname_list.dat"
	_total_chunks = get_chunk_names_from_file(sourcepath)
	
	'	Progress bar
	_Progress_Max = _total_chunks + 1 + 3
	_Progress_Val = 0
	SendMessage(_hProg, PBM_SETRANGE, 0, MAKELPARAM( 0, _Progress_Max ))
	SendMessage(_hProg, PBM_SETPOS, _Progress_Val, 0)
	display_time()

	AddMessage("Extracting pegs.vpp_pc to temporary folder...")

	sourcepath = _ORIGINAL_VPP_PC + "\pegs.vpp_pc"
	destpath = _temppath + _TEMP_PEGS
	SaintsRow2_FileFormats.UnpackFile(sourcepath, destpath)

	DelMessage("")

	_Progress_Val+=1
	SendMessage(_hProg, PBM_SETPOS, _Progress_Val, 0)
	display_time()

	for i = 0 to 2			
		'	extract original chunks data to temporary folder
		ztemp = "Extracting chunks" + libstr.strform_val("", 1, 0, i+1) + ".vpp_pc to temporary folder..."
		AddMessage(ztemp)

		select case i
			case 0
				sourcepath = _ORIGINAL_VPP_PC + "\chunks1.vpp_pc"
			case 1
				sourcepath = _ORIGINAL_VPP_PC + "\chunks2.vpp_pc"
			case 2
				sourcepath = _ORIGINAL_VPP_PC + "\chunks3.vpp_pc"
			case else
		end select
		
		destpath = _temppath + _TEMP_CHUNKS
		SaintsRow2_FileFormats.UnpackFile(sourcepath, destpath)

		DelMessage("")
		
		'	progress bar
		_Progress_Val+=1
		SendMessage(_hProg, PBM_SETPOS, _Progress_Val, 0)
		display_time()
	
		'	copy peg_pc to _TEMP_CHUNKS
		for j = 0 to _chunks(i).num - 1
			sourcepath = _temppath + _TEMP_PEGS + "\" + _chunks(i).chunk(j).name + ".peg_pc"
			destpath = _temppath + _TEMP_CHUNKS
			copy_file(sourcepath, destpath, fbArchive)
		next
				
		'	extract gpeg_pc files
		for j = 0 to _chunks(i).num - 1

			sourcepath = _temppath + _TEMP_CHUNKS + "\" + _chunks(i).chunk(j).name + ".peg_pc"
			destpath = "chunks" + str(i+1) + "\" + _chunks(i).chunk(j).name
			'	check folder existence
			if (dir(destpath, fbDirectory) <> "") then
				'	cleanup files
				ztemp = _chunks(i).chunk(j).name + " delete existing files..."
				AddMessage(ztemp)

				delete_file(destpath + "\*.*", fbArchive)

				DelMessage("")
			endif

			'	extracting
			ztemp = _chunks(i).chunk(j).name + " extract texture data..."
			AddMessage(ztemp)
			peg_pc.extract_peg(sourcepath, destpath)
			DelMessage("")
			
			'	progress bar
			_Progress_Val+=1
			SendMessage(_hProg, PBM_SETPOS, _Progress_Val, 0)
			display_time()
		
		next
		'		cleanup chunks temporary files
		destpath = _temppath + _TEMP_CHUNKS + "\*.*"
		delete_file(destpath, FbArchive)
	next

	'		cleanup peg temporary files
	destpath = _temppath + _TEMP_PEGS + "\*.*"
	delete_file(destpath, FbArchive)	

	'	clear messages
	DelMessage("")

	ztemp = "Extract chunks textures data was completed successfully." + !"\r\n" + "Processing time is " + _elapsed_time_str
	MessageBox(_hDlg, ztemp, @"Info", MB_OK or MB_APPLMODAL)

	'	reset progress bar
	_Progress_Val = 0
	SendMessage(_hProg, PBM_SETPOS, _Progress_Val, 0)
	display_time()

	'	Error handling
	get_error_status()
	reflect_error_status()

	_THREAD_STATUS = THREAD_NOT_IN_USE
	_THREAD_RETURN = F_NOERROR
	
end sub

'----------------------------------------------------------
'	delete all chunks data and initialize
'----------------------------------------------------------
sub init_chunks_data()
	dim as s32 i, j
	dim as string path, fullpath
	dim as zstring*256 ztemp
	
	_THREAD_STATUS = THREAD_IN_USE
	_THREAD_RETURN = F_NOERROR

	'	Progress bar
	_Progress_Max = _TOTAL_CHUNKS_NUMBER
	_Progress_Val = 0
	SendMessage(_hProg, PBM_SETRANGE, 0, MAKELPARAM( 0, _Progress_Max ))
	SendMessage(_hProg, PBM_SETPOS, _Progress_Val, 0)
	display_time()

	for i = 0 to 2
		
		select case i
			case 0
				path = "chunks1\"
			case 1
				path = "chunks2\"
			case 2
				path = "chunks3\"				
		end select
		
		for j = 0 to _chunks(i).num - 1
		
			fullpath = path + _chunks(i).chunk(j).name
			AddMessage(_chunks(i).chunk(j).name)
			delete_file(fullpath + "\*.*", fbArchive)
			RmDir(fullpath)
		
			DelMessage("")
			_Progress_Val+=1
			SendMessage(_hProg, PBM_SETPOS, _Progress_Val, 0)
			display_time()

		next
		
	next

	ztemp = "All chunks texture data was deleted successfully." + !"\r\n" + "Processing time is " + _elapsed_time_str
	MessageBox(_hDlg, ztemp, @"Info", MB_OK or MB_APPLMODAL)

	'	reset progress bar
	_Progress_Val = 0
	SendMessage(_hProg, PBM_SETPOS, _Progress_Val, 0)
	display_time()

	'	error handling
	get_error_status()
	reflect_error_status()

	_THREAD_STATUS = THREAD_NOT_IN_USE
	_THREAD_RETURN = F_NOERROR
	
end sub

'----------------------------------------------------------
'	make chunks texture statistics
'----------------------------------------------------------
sub make_texture_statistics()
	dim chunk_textures(MAX_TEXTURES) as chunk_textures_data
	dim as s32 cn, i, j, k, texn, fh
	dim as s32 mip, imgw, imgh, pixform, flag, exitflag
	dim as string retstr, path, chunkpath, filespec, fullpath
	dim as zstring*64 ztemp

	'	Thread state
	_THREAD_STATUS = THREAD_IN_USE
	
	'	Progress bar
	_Progress_Max = 4
	_Progress_Val = 0
	SendMessage(_hProg, PBM_SETRANGE, 0, MAKELPARAM( 0, _Progress_Max ))
	SendMessage(_hProg, PBM_SETPOS, _Progress_Val, 0)

	AddMessage("Making chunks texture statistics...")
	
	exitflag = false
	texn = 0
	for cn = 0 to 2

		select case cn
			case 0
				path = "chunks1\"
			case 1
				path = "chunks2\"
			case 2
				path = "chunks3\"
			case else
		end select

		for i = 0 to _chunks(cn).num - 1

			ztemp = "searching " + _chunks(cn).chunk(i).name + "..."
			AddMessage(ztemp)
						
			chunkpath = path + _chunks(cn).chunk(i).name + "\"	
			filespec = chunkpath + "*.dds"

			'	get existence texture names in the chunk
			retstr = dir(filespec, fbArchive)
			if (retstr <> "") then
				flag = FALSE
				if (texn > 0) then
					k = texn - 1
					for j = 0 to k
						if (retstr = chunk_textures(j).name) then
							' this texture is already exists
							chunk_textures(j).num += 1
							flag = TRUE
							exit for
						endif
					next
					if (flag = FALSE) then
						' new texture found
						chunk_textures(texn).name = retstr
						chunk_textures(texn).chunkname = _chunks(cn).chunk(i).name
						fullpath = chunkpath + retstr
						mip = dds.load_ddsheader(fullpath, imgw, imgh, pixform)
						chunk_textures(texn).width = imgw
						chunk_textures(texn).height = imgh
						chunk_textures(texn).format = pixform
						chunk_textures(texn).num = 1
						texn+=1
						if (texn > MAX_TEXTURES) then
							exitflag = TRUE
							exit for
						endif
					endif
				else
					' first texture found
					chunk_textures(texn).name = retstr
					chunk_textures(texn).chunkname = _chunks(cn).chunk(i).name
					fullpath = chunkpath + retstr
					mip = dds.load_ddsheader(fullpath, imgw, imgh, pixform)
					chunk_textures(texn).width = imgw
					chunk_textures(texn).height = imgh
					chunk_textures(texn).format = pixform
					chunk_textures(texn).num = 1
					texn+=1
				endif
				
				do
					retstr = dir()
					if (retstr <> "") then
						flag = FALSE
						k = texn - 1
						for j = 0 to k
							if (retstr = chunk_textures(j).name) then
								' this texture is already exists
								chunk_textures(j).num += 1
								flag = TRUE
								exit for
							endif
						next
						if (flag = FALSE) then
							' new texture found
							chunk_textures(texn).name = retstr
							chunk_textures(texn).chunkname = _chunks(cn).chunk(i).name
							fullpath = chunkpath + retstr
							mip = dds.load_ddsheader(fullpath, imgw, imgh, pixform)
							chunk_textures(texn).width = imgw
							chunk_textures(texn).height = imgh
							chunk_textures(texn).format = pixform
							chunk_textures(texn).num = 1
							texn+=1
							if (texn > MAX_TEXTURES) then
								exitflag = TRUE
								exit do
							endif
						endif
					else
						' no more file
						exit do
					endif
				loop while(TRUE)
				if (exitflag = TRUE) then
					exit for
				endif
			endif
			DelMessage("")
		next i
		if (exitflag = TRUE) then 
			DelMessage("")
			exit for
		endif
		_Progress_Val+=1
		SendMessage(_hProg, PBM_SETPOS, _Progress_Val, 0)
	next cn

	if (exitflag) then
		_Progress_Val = 0
		SendMessage(_hProg, PBM_SETPOS, _Progress_Val, 0)
		ztemp = "number of texture excess upper limit!"
		MessageBox(NULL, ztemp, @"Error", MB_OK)
		_THREAD_STATUS = THREAD_NOT_IN_USE
		return
	endif
	
	'	sort texture data (simple bubble sort)
	AddMessage("sorting data...")

	do
		flag = FALSE
		for i = 1 to texn - 1
			if (chunk_textures(i - 1).num < chunk_textures(i).num) then
				swap chunk_textures(i - 1), chunk_textures(i) 
				flag = TRUE
			elseif (chunk_textures(i - 1).num = chunk_textures(i).num) then
				if (chunk_textures(i - 1).name > chunk_textures(i).name) then
					swap chunk_textures(i - 1), chunk_textures(i) 
					flag = TRUE					
				endif
			endif
		next
	loop while (flag = TRUE)

	DelMessage("")
	_Progress_Val+=1
	SendMessage(_hProg, PBM_SETPOS, _Progress_Val, 0)
		
	'	make report file
	
	fh = freefile
	open "texture_statistics.txt" for output as #fh
    print #fh, "Texture Name                             Num  Width  Height  Format   First Found"
    print #fh, "--------------------------------------+-----+------+------+----------+------------------------------"
'              "\                                    \| ####|  ####|  ####| \      \ | &"
'                                                                            A8R8G8B8    
	for i = 0 to texn - 1
		j = chunk_textures(i).num
		imgw = chunk_textures(i).width
		imgh = chunk_textures(i).height
		pixform = chunk_textures(i).format
		select case pixform
			case D3DFMT_DXT1
				retstr = "DXT1 "
			case D3DFMT_DXT3
				retstr = "DXT3 "
			case D3DFMT_DXT5
				retstr = "DXT5 "
			case D3DFMT_A8R8G8B8
				retstr = "A8R8G8B8"
			case D3DFMT_R5G6B5
				retstr = "R5G6B5"
			case else
				retstr = "?????"
		end select
		print #fh, using "\                                    \| ####|  ####|  ####| \      \ | &";chunk_textures(i).name; j; imgw; imgh; retstr; chunk_textures(i).chunkname
	next i
	
	close fh

	_Progress_Val = 0
	SendMessage(_hProg, PBM_SETPOS, _Progress_Val, 0)

	DelMessage("Making chunks texture statistics...")

	_THREAD_STATUS = THREAD_NOT_IN_USE
	
end sub

'----------------------------------------------------------
'	write ini file
'----------------------------------------------------------
function write_inifile(filename as string) as s32
	dim as s32 ret, fh, i
	dim as string st
	
	ret = xml.new_doc(filename, "sr2texturetool")
	if (ret <> XML_NO_ERROR) then
		return(F_ERROR)
	endif
	
	xml.write_single_element("Version", PROGRAM_VERSION)
	xml.new_element("PathSettings")
		xml.write_single_element("SR2Path", _sr2path)
		xml.write_single_element("TempPath", _temppath)
	xml.close_element()
	xml.new_element("PegDirector")
		xml.write_single_element("CheckImageSizeDiff", "FALSE")
		xml.write_single_element("Suppress_extracted", "TRUE")
	xml.close_element()
	xml.new_element("DDSDirector")
		xml.new_element("Const")
			xml.write_single_element("RenderTarget", "SR2")
			xml.write_single_element("SilentMode", "TRUE")
		xml.close_element()
		xml.new_element("DxtDirector")
			select case dds.dds_director.colourfit
				case squish_kColourClusterFit
					st = "ClusterFit"
				case squish_kColourRangeFit
					st = "RangeFit"
				case squish_kColourIterativeClusterFit
					st = "IterativeClusterFit"
				case else
					st = "ClusterFit"
			end select
			xml.write_single_element("ColourFit", st)
		xml.close_element()
		xml.new_element("MipmapDirectors")
			for i = 0 to 2
				xml.new_element("MipmapDirector")
				select case i
					case 0
						xml.write_single_element("Format", "DXT1")
					case 1
						xml.write_single_element("Format", "DXT3orDXT5")
					case 2
						xml.write_single_element("Format", "NORMALMAP")
					case else
				end select				
				st = dds.dds_director.mipmap(i).resize_filter
				xml.write_single_element("Filter", st)
				select case dds.dds_director.mipmap(i).colourspace
					case DDS_sRGB_COLOUR
						st = "sRGB"
					case DDS_LINEAR_COLOUR
						st = "LINEAR"
					case else
				end select
				xml.write_single_element("Colour", st)
				xml.close_element()
			next
		xml.close_element()	'	MipmapDirectors
	xml.close_element()	'	DDSDirector
	xml.close_doc()

	fh = freefile
	open filename for append as #fh
	
	print #fh, "//---------------------------------------------"
	print #fh, "//    Description Help"
	print #fh, "//---------------------------------------------"
	print #fh, "// <CheckImageSizeDiff>"
	print #fh, "//   it must always be FALSE in SR2ChunksTextureTool"
	print #fh, "// <Suppress_extracted>"
	print #fh, "//   FALSE(default)"
	print #fh, "//     add '_extracted' to extract folder name"
	print #fh, "//   TRUE"
	print #fh, "//     do not add '_extracted' to extract folder name"
	print #fh, "// <RenderTarget>"
	print #fh, "//   SR2     (generate mipmap to 4x4)"
	print #fh, "//   GENERIC (generate mipmap to 1x1)"
	print #fh, "// <ColourFit>"
	print #fh, "//   ClusterFit          - Use a slow but high quality colour compressor (default)"
	print #fh, "//   IterativeClusterFit - Use a very slow but very high quality colour compressor"
	print #fh, "//   RangeFit            - Use a fast but low quality colour compressor"
	print #fh, "// <Format> texture format"
	print #fh, "//   DXT1"
	print #fh, "//   DXT3orDXT5"
	print #fh, "//   NORMALMAP"
	print #fh, "// <Filter>  image resize filter"
	print #fh, "//   POINT LINEAR CUBIC FANT BOX TRIANGLE POINT_DITHER"
	print #fh, "//   LINEAR_DITHER CUBIC_DITHER FANT_DITHER BOX_DITHER TRIANGLE_DITHER"
	print #fh, "//   POINT_DITHER_DIFFUSION LINEAR_DITHER_DIFFUSION CUBIC_DITHER_DIFFUSION"
	print #fh, "//   FANT_DITHER_DIFFUSION BOX_DITHER_DIFFUSION TRIANGLE_DITHER_DIFFUSION"
	print #fh, "//   POINT_ADAPTIVE"
	print #fh, "// <Colour> source image color"
	print #fh, "//   sRGB   for general texture"
	print #fh, "//   LINEAR for normalmap/tgn"
	close #fh
	
	return(F_NOERROR)

end function

'----------------------------------------------------------
'	read ini file
'----------------------------------------------------------
function read_inifile(filename as string) as s32
	dim as s32 i, n, ret, texture_format
	dim as string ename, evalue
	dim as zstring*256 ztemp
	
	'	open ini file
	ret = xml.read_doc(filename)
	if (ret <> XML_NO_ERROR) then
		ztemp = "Can't read " + _INIFILE_NAME
		MessageBox(NULL, ztemp, @"Error", MB_OK)
		xml.close_doc()
		return(F_ERROR)
	endif

	'	<sr2texturetool>
	ret = xml.read_element(ename, evalue)
	if (ename <> "sr2texturetool") then
		ztemp = _INIFILE_NAME + " <sr2texturetool> missing"
		MessageBox(NULL, ztemp, @"Error", MB_OK)
		xml.close_doc()
		return(F_ERROR)
	endif
	
	'	<Version>
	ret = xml.read_element(ename, evalue)
	if (ename <> "Version") then
		ztemp = _INIFILE_NAME + " missing. " + ename
		MessageBox(NULL, ztemp, @"Error", MB_OK)
		xml.close_doc()
		return(F_ERROR)
	elseif (val(evalue) <> val(PROGRAM_VERSION)) then
		ztemp = _INIFILE_NAME + " <Version> not match. " + evalue
		MessageBox(NULL, ztemp, @"Error", MB_OK)
		xml.close_doc()
		return(F_ERROR)
	endif

	'	<PathSettings>
	ret = xml.read_element(ename, evalue)
	if (ename <> "PathSettings") then
		ztemp = _INIFILE_NAME + " <PathSettings> missing"
		MessageBox(NULL, ztemp, @"Error", MB_OK)
		xml.close_doc()
		return(F_ERROR)
	endif
	do
		ret = xml.read_element(ename, evalue)
		select case ename
			case "SR2Path"
				_sr2path = trim(evalue)
			case "TempPath"
				_temppath = trim(evalue)
				if (_temppath = "") then
					ztemp = _INIFILE_NAME + " <_temppath> block is blank."
					MessageBox(NULL, ztemp, @"Error", MB_OK)
					xml.close_doc()
					return(F_ERROR)
				endif
			case "/PathSettings"
				exit do
			case else
				ztemp = _INIFILE_NAME + " <PathSettings> block syntax error. " + ename
				MessageBox(NULL, ztemp, @"Error", MB_OK)
				xml.close_doc()
				return(F_ERROR)
		end select
	loop while (true)

	'	<PegDirector>
	ret = xml.read_element(ename, evalue)
	if (ename <> "PegDirector") then
		ztemp = _INIFILE_NAME + " <PegDirector> missing. " + ename
		MessageBox(NULL, ztemp, @"Error", MB_OK)
		xml.close_doc()
		return(F_ERROR)
	endif
	
	do
		ret = xml.read_element(ename, evalue)
		select case ename
			case "CheckImageSizeDiff"
				select case lcase(evalue)
					case "true"
						peg_pc.peg_director.check_imagesize_difference = TRUE
					case "false"
						peg_pc.peg_director.check_imagesize_difference = FALSE
					case else						
						ztemp = _INIFILE_NAME + " <CheckImageSizeDiff> value wrong. " + evalue
						MessageBox(NULL, ztemp, @"Error", MB_OK)
						xml.close_doc()
						return(F_ERROR)
				end select
			case "Suppress_extracted"
				select case lcase(evalue)
					case "true"
						peg_pc.peg_director.suppress_extracted = TRUE
					case "false"
						peg_pc.peg_director.suppress_extracted = FALSE
					case else
						ztemp = _INIFILE_NAME + " <Suppress_extracted> value wrong. " + evalue
						MessageBox(NULL, ztemp, @"Error", MB_OK)
						xml.close_doc()
						return(F_ERROR)
				end select
			case "/PegDirector"
				exit do
			case else
				ztemp = _INIFILE_NAME + " <PegDirector> block syntax error. " + ename
				MessageBox(NULL, ztemp, @"Error", MB_OK)
				xml.close_doc()
				return(F_ERROR)
		end select
	loop while (true)

	'	<DDSDirector>
	ret = xml.read_element(ename, evalue)
	if (ename <> "DDSDirector") then
		ztemp = _INIFILE_NAME + " <DDSDirector> missing"
		MessageBox(NULL, ztemp, @"Error", MB_OK)
		xml.close_doc()
		return(F_ERROR)
	endif

	'	<Const>
	ret = xml.read_element(ename, evalue)	'Const
	if (ename <> "Const") then
		ztemp = _INIFILE_NAME + " <Const> missing"
		MessageBox(NULL, ztemp, @"Error", MB_OK)
		xml.close_doc()
		return(F_ERROR)
	endif
	do
		ret = xml.read_element(ename, evalue)
		select case ename
			case "RenderTarget"
				select case evalue
					case "SR2"
						dds.dds_director.render_target = DDS_SR2_ENGINE
					case "GENERIC"
						dds.dds_director.render_target = DDS_GENERIC_ENGINE
					case else
						ztemp = _INIFILE_NAME + " wrong description in <RenderTarget>. " + evalue
						MessageBox(NULL, ztemp, @"Error", MB_OK)
						xml.close_doc()
						return(F_ERROR)
				end select
			case "SilentMode"
				select case lcase(evalue)
					case "true"
						dds.dds_director.silentmode = TRUE
					case "false"
						dds.dds_director.silentmode = FALSE
					case else
						ztemp = _INIFILE_NAME + " wrong description in <SilentMode>. " + evalue
						MessageBox(NULL, ztemp, @"Error", MB_OK)
						xml.close_doc()
						return(F_ERROR)
				end select
			case "/Const"
				exit do
			case else
				ztemp = _INIFILE_NAME + " <Const> block syntax error. " + ename
				MessageBox(NULL, ztemp, @"Error", MB_OK)
				xml.close_doc()
				return(F_ERROR)
		end select
	loop while (true)

	'	<DxtDirector>
	ret = xml.read_element(ename, evalue)	'Const
	if (ename <> "DxtDirector") then
		ztemp = _INIFILE_NAME + " <DxtDirector> missing"
		MessageBox(NULL, ztemp, @"Error", MB_OK)
		xml.close_doc()
		return(F_ERROR)
	endif
	do
		ret = xml.read_element(ename, evalue)
		select case ename
			case "ColourFit"
				select case evalue
					case "ClusterFit"
						dds.dds_director.colourfit = squish.kColourClusterFit
					case "IterativeClusterFit"
						dds.dds_director.colourfit = squish.kColourIterativeClusterFit
					case "RangeFit"
						dds.dds_director.colourfit = squish.kColourRangeFit
					case else
						ztemp = _INIFILE_NAME + " wrong description in <ColourFit>. " + evalue
						MessageBox(NULL, ztemp, @"Error", MB_OK)
						xml.close_doc()
						return(F_ERROR)
				end select
			case "/DxtDirector"
				exit do
			case else
				ztemp = _INIFILE_NAME + " <DxtDirector> block syntax error. " + ename
				MessageBox(NULL, ztemp, @"Error", MB_OK)
				xml.close_doc()
				return(F_ERROR)
		end select
	loop while (true)

	'	read MipmapDirector settings
	ret = xml.read_element(ename, evalue)
	if (ename <> "MipmapDirectors") then
		ztemp = _INIFILE_NAME + " <MipmapDirectors> missing"
		MessageBox(NULL, ztemp, @"Error", MB_OK)
		xml.close_doc()
		return(F_ERROR)		
	endif
	do
		ret = xml.read_element(ename, evalue)
		select case ename
			case "MipmapDirector"
				'	nop
			case "Format"
				select case evalue
					case "NORMALMAP"
						texture_format = DDS_MIPMAP_NORMALMAP
					case "DXT1"
						texture_format = DDS_MIPMAP_DXT1
					case "DXT3orDXT5"
						texture_format = DDS_MIPMAP_DXT3_DXT5
					case else
						ztemp = _INIFILE_NAME + " wrong description in <Format>. " + evalue
						MessageBox(NULL, ztemp, @"Error", MB_OK)
						xml.close_doc()
						return(F_ERROR)
				end select
			case "Filter"
				dds.dds_director.mipmap(texture_format).resize_filter = trim(evalue)
			case "Colour"
				select case evalue
					case "sRGB"
						dds.dds_director.mipmap(texture_format).colourspace = DDS_sRGB_COLOUR
					case "LINEAR"
						dds.dds_director.mipmap(texture_format).colourspace = DDS_LINEAR_COLOUR
					case else
						ztemp = _INIFILE_NAME + " <Colour> value wrong. " + evalue
						MessageBox(NULL, ztemp, @"Error", MB_OK)
						xml.close_doc()
						return(F_ERROR)
				end select
			case "/MipmapDirector"
				'	nop
			case "/MipmapDirectors"
				exit do
			case else
				ztemp = _INIFILE_NAME + " <MipmapDirector> block syntax error. " + ename
				MessageBox(NULL, ztemp, @"Error", MB_OK)
				xml.close_doc()
				return(F_ERROR)
		end select
	loop while (true)

	ret = xml.read_element(ename, evalue)	' </DDSDirector>
	ret = xml.read_element(ename, evalue)	' </sr2chumktool>
	xml.close_doc()

	return(F_NOERROR)
end function
